#!/bin/bash                                                                                                                                                   

# Script GetGuignols.sh permettant de télécharger l'épisode des Guignols de l'Info en HTTP
# Écrit par Tito pour Geekfault (http://geekfault.be)
# Distribué sous license GNU/GPLv3

# UTILISATION :
# Pensez à augmenter les chiffres ligne 33 et 40 si c'est la première fois que vous utilisez ce script.
# $ ./GetGuignols.sh 		#Récupère l'épisode de la veille, en se basant sur le fichier LastCode
# $ ./GetGuignols.sh 0 		#Récupère l'épisode d'aujourd'hui, en se basant sur le fichier LatCode
# $ ./GetGuignols.sh 3 2580	#Récupère l'épisode d'il y a 3 jours, en cherchant à partir du code 2580
# NB : Il n'y a pas d'épisode les samedis et dimanche
# Plus d'infos : http://geekfault.be/2009/04/10/telecharger-guingols-de-l-info/


if [ -z $1 ]; then
	DATE="1 days ago" # Par défaut, télécharge l'épisode de la veille
else
	if [ $1 == "aujourdhui" ]; then
		DATE="0 days ago"
	elif [ $1 == "hier" ]; then
		DATE="1 days ago"
	elif [ $1 == "avant-hier" ]; then
		DATE="2 days ago"
	else
		DATE="$1 days ago"
	fi
fi

if [ -z $2 ]; then
	if [ -f LastCode ]; then
		MINCODE=`cat LastCode` # Récupère le premier code à essayer du fichier LastCode
		let CODE=MINCODE+1 # Évite de télécharger deux fois le même épisode
		let MAXCODE=MINCODE+100 # Rechercher les 100 codes suivants. Augmentez ce chiffre si vous ne téléchargez pas les Guignols tous les jours
	else
		MINCODE=3087 # Code initial de ce script. Augmentez ce chiffre si c'est la première fois que vous l'utilisez
		let CODE=MINCODE+1 # Évite de télécharger deux fois le même épisode
		let MAXCODE=MINCODE+1000
		echo -e "\033[1;31mApparemment c'est la première fois que vous utilisez ce script. Nous allons essayer jusqu'à 1000 URL différentes! Cela peut prendre du temps.\033[0m"
		echo -e "\033[1;31mPour quitter ce script avant la fin de l'exécution, pressez Ctrl+C.\033[0m"
	fi
else
	MINCODE=$2
fi



echo -e "\033[1m  *  Le script va maintenant rechercher l'épisode des Guignols de l'Info du `date +%d/%m/%y --date "$DATE"`, avec une clé comprise entre $CODE et $MAXCODE\033[0m"
while [ $CODE -lt $MAXCODE ]; do
	TRYURL=http://vod-flash.canalplus.fr/WWWPLUS/STREAMING/`date +%y%m --date "$DATE"`/LES_GUIGNOLS_QUOTIDIEN_`date +%y%m%d --date "$DATE"`_AUTO_`echo $CODE`_169_video_H.flv
	wget --spider --quiet $TRYURL # Prétend un téléchargement pour voir si le fichier existe
	
	if [ $? == 0 ]; then # On a trouvé l'épisode!
		echo -e "\033[1;32m  *  TROUVÉ!\033[0m \033[1mLa clé du `date +%d/%m/%y --date "$DATE"` est $CODE et le fichier est accessible à l'adresse\033[0m"
		echo -e "\033[1m  *  \033[0m        $TRYURL"
		echo ""
		wget $TRYURL # Télécharge l'épisode
		if [ -n $2 ]; then
			echo $CODE > LastCode # Enregistre le code pour ne pas repartir à zéro lors de la prochaine exécution
		fi
		echo "`date +%d/%m/%y --date "$DATE"` : $TRYURL" >> Historique # Ajoute l'adresse trouvé dans l'historique
		let CODE=MAXCODE+1 # Quitte la boucle
		echo -e "\033[1;32m  *  Bon visionnage ;)\033[0m"
	fi
	let CODE=CODE+1
done

if [ $CODE == $MAXCODE ]; then #On a essayé tous les codes sans réussir à télécharger de fichier
	echo -e "\033[1;31m  *  Désolé, nous n'avons pas pu trouver l'épisode des Guignols de l'Info du `date +%d/%m/%y --date "$DATE"` avec une clé comprise entre $MINCODE et $MAXCODE\033[0m"
	echo -e "\033[1;31m  *  Le fichier LastCode n'a pas été modifié.\033[0m"
fi
